<script setup lang="ts">
import { ref } from "vue";
import Category from "../types/category";
import Priority from "../types/priority";

// Pour ouvrir la modale
const showModal = ref<boolean>(false);

// Appel API
const { baseURL }: { baseURL: string } = useRuntimeConfig().app;
const authorizationHeader = useAuthorizationHeader("application/json");

const { data: priorities } = await useFetch<Priority>(baseURL + "api/priorities", {
  headers: authorizationHeader,
});

const { data: categories } = await useFetch<Category>(baseURL + "api/categories", {
  headers: authorizationHeader,
});

const selectedPriority = ref<Priority[]>();
const selectedCategories = ref<Category[]>();

// Fonction pour gérer les clics sur les boutons de priorité et catégories 
function togglePressed(item: Priority | Category, type: "priority" | "category") {
  item.pressed = !item.pressed;

  if (type === "priority") {
    if (item.pressed) {
      selectedPriority.value.push(item as Priority);
    } else {
      selectedPriority.value = selectedPriority.value.filter(
        (priority) => priority.id !== item.id
      );
    }
  } else if (type === "category") {
    if (item.pressed) {
      selectedCategories.value.push(item as Category);
    } else {
      selectedCategories.value = selectedCategories.value.filter(
        (category) => category.id !== item.id
      );
    }
  }
}
</script>

<template>
  <nav class="fr-grid-row">
    <section class="fr-col-9 fr-pl-1w">
      <ul class="fr-grid-row fr-grid-row--middle fr-pt-2w tags-list">
        <li>
          <ul
            class="fr-tags-group fr-grid-row--middle fr-mr-1v tags-priorite-intervention tags-list"
          >
            <li v-for="priority in priorities">
              <button
                :class="['fr-tag', { urgent: priority.name === 'Urgent' }]"
                :aria-pressed="priority.pressed"
                @click="togglePressed(priority, 'priority')"
                :value="`/priorities/${priority.id}`"
              >
                {{ priority.name }}
              </button>
            </li>
          </ul>
        </li>
        <li class="fr-hr"></li>
        <li>
          <ul
            class="fr-tags-group fr-grid-row--middle fr-pl-1w tags-types-interventions tags-list"
          >
            <li v-for="category in categories">
              <button
                class="fr-tag"
                :aria-pressed="category.pressed"
                @click="togglePressed(category, 'category')"
                :value="`/categories/${category.id}`"
              >
                {{ category.name }}
              </button>
            </li>
          </ul>
        </li>
      </ul>
    </section>
    <button
      @click="showModal = true"
      class="fr-icon-equalizer-line fr-my-2w fr-ml-2w fr-px-2w list-button"
    ></button>
    <Modal :show="showModal" @close="showModal = false">
      <Filter />
    </Modal>
  </nav>
</template>

<style scoped>
section > ul {
  overflow-x: auto;
}

.tags-list {
  flex-wrap: nowrap;
}

.fr-hr {
  border-left: 0.063rem solid var(--border-default-grey);
}

li {
  list-style: none;
}

.list-button {
  border: 0.063rem solid var(--border-default-grey);
  color: var(--background-active-blue-france);
  border-radius: 3.125rem;
}

button.fr-tag {
  width: max-content;
}

.urgent {
  background-color: var(--background-contrast-warning);
  color: var(--text-action-high-purple-glycine);
}

button.urgent[aria-pressed="false"] {
  background-color: var(--background-contrast-warning);
  color: var(--text-action-high-purple-glycine);
}

button.urgent[aria-pressed="true"]:not(:disabled):hover {
  background-image: radial-gradient(
    circle at 100% 0.25rem,
    transparent 0.578125rem,
    var(--background-action-high-warning) 0.625rem
  );
}
</style>
